-------------------
-- PAQUET GESTIO --
-------------------




---------------------------------------------------------------------
-- omplim algunes peticions de material per par dels usuaris
---------------------------------------------------------------------

select demanar_material ('USU1000001', 'TIP1000001', 1);
select demanar_material ('USU1000002', 'TIP1000002', 2);
select demanar_material ('USU1000003', 'TIP1000003', 2);
select demanar_material ('USU1000003', 'TIP1000001', 1);
select demanar_material ('USU1000003', 'TIP1000002', 1);
select demanar_material ('USU1000005', 'TIP1000001', 2);
select demanar_material ('USU1000005', 'TIP1000003', 1);






------------------------------------------------------------------------
-- l-usuari responsable autoritzara algunes peticions de material
------------------------------------------------------------------------

select aprovar_peticio ('USU1000001', 'PET1000001');
select aprovar_peticio ('USU1000002', 'PET1000002');
select aprovar_peticio ('USU1000003', 'PET1000003');
select aprovar_peticio ('USU1000003', 'PET1000004');

-- intent d-aprovar una peticio per un usuari que no es responsable del departament
-------------------------------------------------------------------------------------

select aprovar_peticio ('USU1000001', 'PET1000004');





-- rebutjem alguna peticio
--------------------------------------------------------------------------------------

select rebutjar_peticio ('USU1000001', 'PET1000001');



-- intent de rebutjar una peticio per un usuari que no es responsable del departament
--------------------------------------------------------------------------------------

select rebutjar_peticio ('USU1000001', 'PET1000004');

--------------------------------------------------------------------------------------




------------------------------------------------------------------------------------
-- consulta per part de l-usuari subministraments, de les peticions aprovades
-------------------------------------------------------------------------------------

select consultar_peticions_aprovades ();

--------------------------------------------------------------------------------------






-----------------------------------------------------------------------------------------
-- assignarem dispositius a usuaris
-----------------------------------------------------------------------------------------
-- nomes te permisos per a executar aquesta funcio l-usuari tecnic
-----------------------------------------------------------------------------------------



select moviment_dispositiu ('assignacio', 'DIS1000001', '', 'USU1000001');
select moviment_dispositiu ('assignacio', 'DIS1000002', '', 'USU1000002');
select moviment_dispositiu ('assignacio', 'DIS1000003', '', 'USU1000003');
select moviment_dispositiu ('assignacio', 'DIS1000005', '', 'USU1000003');

--------------------------------------------------------------
-- ara farem algun moviment del tipus reassignacio
---------------------------------------------------------------

select moviment_dispositiu ('reassignacio', 'DIS1000001', 'USU1000001', 'USU1000002');
select moviment_dispositiu ('reassignacio', 'DIS1000003', 'USU1000003', 'USU1000002');




---------------------------------------------------------------------------------
-- amb les accions realitzades ja tindrem informacio en algunes
-- de les taules estadistiques
--------------------------------------------------------------------------------



-- est5 - nombre de dispositius actius d-un departament

select consultar_est5('DEP1000002');



-- est6 - per a cada departament,valor economic de l-inventari

select consultar_est6();




-- est9 - percentatge d-usuaris que no tenen cap dispositiu assignat

select consultar_est9();




-- est11 - departament que te ms tipus de dispositius i quants

select consultar_est11();




-- est12 - nombre d-usuaris amb mes de 5 dispositius

select consultar_est12();



-- est8 departament que en un any fa mes moviments del tipus reassignacio,
-- que retorna dos departaments ja que n-hi ha un empat

select consultar_est8(2016);







--------------------------------------------------------
-- regristrem una avaria d-un dispositiu
---------------------------------------------------------

select registrar_avaria ('DIS1000001','rotura pantalla');
select registrar_avaria ('DIS1000002','falla la font d-alimentacio');
select registrar_avaria ('DIS1000003','falla la font d-alimentacio');






-- ara ja tindrem actualitzades les estadistiques...
------------------------------------------------------------


-- est2 percentatge de portatils sense avaries des de l-assignacio a un usuari

select consultar_est2();





-- est13 nombre d-avaries en un any a tota l-empresa

select consultar_est13(2016);




-- est14 Top10 d-usuaris per avaries

select consultar_est14();




-- enregistrem una reparacio
--------------------------------------

select registrar_reparacio ('AVA1000001');



-- no hem implementar cap funcio per a vore aquesta informacio pero
-- comprovem que ha sigut registrada amb un select

select * from avaries
where id_avaria = 'AVA1000001';


-- i que el dispositiu te marcat el camp avariat a FALSE

select * from dispositiu
where codi_dispositiu IN (
                         select codi_dispositiu
                         from avaries
                         where id_avaria = 'AVA1000001'
                         );









--------------------------------------------------------------------------------------
-- ara pasem a la part relativa a les compres i recepcio del material
--------------------------------------------------------------------------------------


-- primer definirem un parell d-articles que formaran part del pla d-inversions
----------------------------------------------------------------------------------
-- nomes l-usuari comptabilitat podra executar aquesta accio
---------------------------------------------------------------------------------


select definir_pla_inversions (2016, 'TIP1000001', 10, 5300.00);
select definir_pla_inversions (2016, 'TIP1000002', 5, 850.00);






-- ara demanem pressupost a un proveidor
------------------------------------------------
-- ho fara l-usuari subministraments
------------------------------------------------

select demanar_pressupost ('PRO1000001');
select inserir_linia_pressupost ('PRE1000001', 'TIP1000001');



-- quan ens arriba la resposta per part del proveidor introduiriem el preu
---------------------------------------------------------------------------

select actualitzar_preu_pressupost ('PRE1000001', 1, 512.50);










-- tenint el preu ja podem fer la comanda al proveidor
------------------------------------------------------------


-- farem una comanda que correspon a una ordre d-inversio
---------------------------------------------------------------

select fer_comanda('PRO1000001', true);
select inserir_linia_comanda ('COM1000001', 'TIP1000001', 2, 512.50);





-- comprovem que s-ha actualitzat l-estadistica est3
-- import total de les comandes lligades a ordre d-inversio
----------------------------------------------------------------

select consultar_est3(2016);




-- intentarem inserir una linia de comanda d-un tipus de dispositiu que no
-- estiga inclos en el pla d-inversions de l-exercici actual

select inserir_linia_comanda ('COM1000001', 'TIP1000003', 2, 125.12);





-- ara intentarem inserir una linia de comanda per un import superior a l-import
-- restant per a eixe tipus de dispositiu al pla d-inversions

select inserir_linia_comanda ('COM1000001', 'TIP1000001', 2, 12111.25);






-- ara farem la recepci de la comanda
----------------------------------------------
-- podran fer-la els usuaris tecnic o encarregat
-----------------------------------------------------

select recepcionar_dispositiu ('COM1000001', 1, 'lksdjflkasd78');






-- comprovem que s-ha inserit el registre a la taula recepcio_material
----------------------------------------------------------------------------

select * from recepcio_material;



-- i que s-ha donat d-alta el dispositius a la taula dispositiu
-- i el seu valor es el preu de compra
----------------------------------------------------------------------------

SELECT * FROM dispositiu ORDER BY codi_dispositiu DESC LIMIT 1;



-- recepcionem la segona unitat de la comanda
---------------------------------------------------------------------------------------

select recepcionar_dispositiu ('COM1000001', 1, 'asdfasdfasd998');




-- tornem a comprovar que s-ha inserit a la taula recepcio_material
-----------------------------------------------------------------------------------

select * from recepcio_material;




-- i que s-ha registrat un nou dispositiu a la taula dispositiu
---------------------------------------------------------------------

SELECT * FROM dispositiu ORDER BY codi_dispositiu DESC LIMIT 1;




-- si intentem recepcionar un tercer dispositiu (nomes es demanaren 2 unitats)
---------------------------------------------------------------------------------

select recepcionar_dispositiu ('COM1000001', 1, 'weoriuowqe77');



-- l-usuari comptabilitat podra comprovar els articles que s-han rebut durant
-- un exercici comptable per a procedir a l-amortitzacio comptable (tasca que
-- queda fora de l-abast d-aquest treball)
-------------------------------------------------------------------------------

select controlar_amortitzacio (2016);



-- anualment sera obligatoria la realitzacio d-un inventari fisic per tal
-- de comprobar que cada departament te, els dispositius que li consten
-- assignats als seus usuaris
-- l-usuari que podra fer l-inventari sera el responsable del departament
------------------------------------------------------------------------------

select fer_inventari_anual ('USU1000002', 'DEP1000002');

select inserir_linia_inventari ('INV1000001', 'DIS1000001');
select inserir_linia_inventari ('INV1000001', 'DIS1000002');
select inserir_linia_inventari ('INV1000001', 'DIS1000003');



-- si repetim l-introduccio d-un dispositiu
----------------------------------------------------------------------

select inserir_linia_inventari ('INV1000001', 'DIS1000001');



-- si intentem inventariar un dispositiu que no esta associat a un usuari
-- del departament que estem inventariant
-------------------------------------------------------------------------

select inserir_linia_inventari ('INV1000001', 'DIS1000004');


-- per acabar, assignarem els dos dispositius comprats, mes un que inserirem
-- a la taula dispositiu, a l'usuari "USU1000002"
-- per a comprovar que s'actualitza l'estadstica 12

select alta_dispositiu ('TIP1000001', 'LLLLUU89', 503.27);

select moviment_dispositiu ('assignacio', 'DIS1000006', '', 'USU1000002');
select moviment_dispositiu ('assignacio', 'DIS1000007', '', 'USU1000002');
select moviment_dispositiu ('assignacio', 'DIS1000008', '', 'USU1000002');




-- est12 - nombre d-usuaris amb mes de 5 dispositius

select consultar_est12();










